/*
 * dumper.h
 *
 *   Copyright (c) 2008, Ueda Laboratory LMNtal Group <lmntal@ueda.info.waseda.ac.jp>
 *   All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions are
 *   met:
 *
 *    1. Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *    2. Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in
 *       the documentation and/or other materials provided with the
 *       distribution.
 *
 *    3. Neither the name of the Ueda Laboratory LMNtal Group nor the
 *       names of its contributors may be used to endorse or promote
 *       products derived from this software without specific prior
 *       written permission.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: dumper.h,v 1.3 2008/09/19 05:18:17 taisuke Exp $
 */

#ifndef LMN_DUMPER_H
#define LMN_DUMPER_H

#include "lmntal.h"
#include "slim_header/port.h"

LMN_EXTERN void dumper_init(void);
LMN_EXTERN void dumper_finalize(void);
LMN_EXTERN void lmn_dump_mem_stdout(LmnMembrane *mem);
LMN_EXTERN void lmn_dump_mem(LmnMembrane *mem, LmnPort port);
LMN_EXTERN void lmn_dump_mem_dev(LmnMembrane *mem);
LMN_EXTERN void lmn_dump_cell_stdout(LmnMembrane *mem);
LMN_EXTERN void lmn_dump_cell(LmnMembrane *mem, LmnPort port);
LMN_EXTERN void lmn_dump_dot(LmnMembrane *mem);
LMN_EXTERN void lmn_dump_atom(LmnPort port, LmnWord atom, LmnLinkAttr attr);

void dump_escaped(LmnPort port, const char *s);

extern char char_to_escape_char[];

#endif /* LMN_DUMPER_H */
